Index: /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3645)
+++ /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3646)
@@ -11,4 +11,6 @@
    !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!            3.5  !  2012     (S. Mocavero, I. Epicoco) Updates for the 
+   !!                             optimization of BDY communications
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -76,4 +78,8 @@
       CHARACTER(LEN=80),DIMENSION(jpbgrd)  ::   clfile
       CHARACTER(LEN=1),DIMENSION(jpbgrd)   ::   cgrid
+      INTEGER :: com_east, com_west, com_south, com_north          ! Flags for boundaries sending
+      INTEGER :: com_east_b, com_west_b, com_south_b, com_north_b  ! Flags for boundaries receiving
+      INTEGER :: iw_b(4), ie_b(4), is_b(4), in_b(4)                ! Arrays for neighbours coordinates
+
       !!
       NAMELIST/nambdy/ nb_bdy, ln_coords_file, cn_coords_file,             &
@@ -543,4 +549,58 @@
       in = mjg(1) + nlcj-1 - 1   ! if monotasking and no zoom, in=jpjm1
 
+      ALLOCATE( nbondi_bdy(nb_bdy))
+      ALLOCATE( nbondj_bdy(nb_bdy))
+      nbondi_bdy(:)=2
+      nbondj_bdy(:)=2
+      ALLOCATE( nbondi_bdy_b(nb_bdy))
+      ALLOCATE( nbondj_bdy_b(nb_bdy))
+      nbondi_bdy_b(:)=2
+      nbondj_bdy_b(:)=2
+
+      ! Work out dimensions of boundary data on each neighbour process
+      IF(nbondi .eq. 0) THEN
+         iw_b(1) = jpizoom + nimppt(nowe+1)
+         ie_b(1) = jpizoom + nimppt(nowe+1)+nlcit(nowe+1)-3
+         is_b(1) = jpjzoom + njmppt(nowe+1)
+         in_b(1) = jpjzoom + njmppt(nowe+1)+nlcjt(nowe+1)-3
+
+         iw_b(2) = jpizoom + nimppt(noea+1)
+         ie_b(2) = jpizoom + nimppt(noea+1)+nlcit(noea+1)-3
+         is_b(2) = jpjzoom + njmppt(noea+1)
+         in_b(2) = jpjzoom + njmppt(noea+1)+nlcjt(noea+1)-3
+      ELSEIF(nbondi .eq. 1) THEN
+         iw_b(1) = jpizoom + nimppt(nowe+1)
+         ie_b(1) = jpizoom + nimppt(nowe+1)+nlcit(nowe+1)-3
+         is_b(1) = jpjzoom + njmppt(nowe+1)
+         in_b(1) = jpjzoom + njmppt(nowe+1)+nlcjt(nowe+1)-3
+      ELSEIF(nbondi .eq. -1) THEN
+         iw_b(2) = jpizoom + nimppt(noea+1)
+         ie_b(2) = jpizoom + nimppt(noea+1)+nlcit(noea+1)-3
+         is_b(2) = jpjzoom + njmppt(noea+1)
+         in_b(2) = jpjzoom + njmppt(noea+1)+nlcjt(noea+1)-3
+      ENDIF
+
+      IF(nbondj .eq. 0) THEN
+         iw_b(3) = jpizoom + nimppt(noso+1)
+         ie_b(3) = jpizoom + nimppt(noso+1)+nlcit(noso+1)-3
+         is_b(3) = jpjzoom + njmppt(noso+1)
+         in_b(3) = jpjzoom + njmppt(noso+1)+nlcjt(noso+1)-3
+
+         iw_b(4) = jpizoom + nimppt(nono+1)
+         ie_b(4) = jpizoom + nimppt(nono+1)+nlcit(nono+1)-3
+         is_b(4) = jpjzoom + njmppt(nono+1)
+         in_b(4) = jpjzoom + njmppt(nono+1)+nlcjt(nono+1)-3
+      ELSEIF(nbondj .eq. 1) THEN
+         iw_b(3) = jpizoom + nimppt(noso+1)
+         ie_b(3) = jpizoom + nimppt(noso+1)+nlcit(noso+1)-3
+         is_b(3) = jpjzoom + njmppt(noso+1)
+         in_b(3) = jpjzoom + njmppt(noso+1)+nlcjt(noso+1)-3
+      ELSEIF(nbondj .eq. -1) THEN
+         iw_b(4) = jpizoom + nimppt(nono+1)
+         ie_b(4) = jpizoom + nimppt(nono+1)+nlcit(nono+1)-3
+         is_b(4) = jpjzoom + njmppt(nono+1)
+         in_b(4) = jpjzoom + njmppt(nono+1)+nlcjt(nono+1)-3
+      ENDIF
+
       DO ib_bdy = 1, nb_bdy
          DO igrd = 1, jpbgrd
@@ -585,4 +645,13 @@
          ! -----------------------------------------------------------------
 
+         com_east = 0
+         com_west = 0
+         com_south = 0
+         com_north = 0
+
+         com_east_b = 0
+         com_west_b = 0
+         com_south_b = 0
+         com_north_b = 0
          DO igrd = 1, jpbgrd
             icount  = 0
@@ -598,10 +667,171 @@
                      idx_bdy(ib_bdy)%nbi(icount,igrd)   = nbidta(ib,igrd,ib_bdy)- mig(1)+1
                      idx_bdy(ib_bdy)%nbj(icount,igrd)   = nbjdta(ib,igrd,ib_bdy)- mjg(1)+1
+                     ! check if point has to be sent
+                     ii = idx_bdy(ib_bdy)%nbi(icount,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(icount,igrd)
+                     if((com_east .ne. 1) .and. (ii .eq. (nlci-1)) .and. (nbondi .le. 0)) then
+                        com_east = 1
+                     elseif((com_west .ne. 1) .and. (ii .eq. 2) .and. (nbondi .ge. 0) .and. (nbondi .ne. 2)) then
+                        com_west = 1
+                     endif 
+                     if((com_south .ne. 1) .and. (ij .eq. 2) .and. (nbondj .ge. 0) .and. (nbondj .ne. 2)) then
+                        com_south = 1
+                     elseif((com_north .ne. 1) .and. (ij .eq. (nlcj-1)) .and. (nbondj .le. 0)) then
+                        com_north = 1
+                     endif 
                      idx_bdy(ib_bdy)%nbr(icount,igrd)   = nbrdta(ib,igrd,ib_bdy)
                      idx_bdy(ib_bdy)%nbmap(icount,igrd) = ib
                   ENDIF
+                  ! check if point has to be received from a neighbour
+                  IF(nbondi .eq. 0) THEN
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(1) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(1) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(1) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(1) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ii = nbidta(ib,igrd,ib_bdy)- iw_b(1)+2
+                       if((com_west_b .ne. 1) .and. (ii .eq. (nlcit(nowe+1)-1))) then
+                          ij = nbjdta(ib,igrd,ib_bdy) - is_b(1)+2
+                          if((ij .eq. 2) .and. (nbondj .eq. 0 .or. nbondj .eq. 1)) then
+                            com_south = 1
+                          elseif((ij .eq. nlcjt(nowe+1)-1) .and. (nbondj .eq. 0 .or. nbondj .eq. -1)) then
+                            com_north = 1
+                          endif
+                          com_west_b = 1
+                       endif 
+                     ENDIF
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(2) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(2) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(2) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(2) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ii = nbidta(ib,igrd,ib_bdy)- iw_b(2)+2
+                       if((com_east_b .ne. 1) .and. (ii .eq. 2)) then
+                          ij = nbjdta(ib,igrd,ib_bdy) - is_b(2)+2
+                          if((ij .eq. 2) .and. (nbondj .eq. 0 .or. nbondj .eq. 1)) then
+                            com_south = 1
+                          elseif((ij .eq. nlcjt(noea+1)-1) .and. (nbondj .eq. 0 .or. nbondj .eq. -1)) then
+                            com_north = 1
+                          endif
+                          com_east_b = 1
+                       endif 
+                     ENDIF
+                  ELSEIF(nbondi .eq. 1) THEN
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(1) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(1) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(1) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(1) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ii = nbidta(ib,igrd,ib_bdy)- iw_b(1)+2
+                       if((com_west_b .ne. 1) .and. (ii .eq. (nlcit(nowe+1)-1))) then
+                          ij = nbjdta(ib,igrd,ib_bdy) - is_b(1)+2
+                          if((ij .eq. 2) .and. (nbondj .eq. 0 .or. nbondj .eq. 1)) then
+                            com_south = 1
+                          elseif((ij .eq. nlcjt(nowe+1)-1) .and. (nbondj .eq. 0 .or. nbondj .eq. -1)) then
+                            com_north = 1
+                          endif
+                          com_west_b = 1
+                       endif 
+                     ENDIF
+                  ELSEIF(nbondi .eq. -1) THEN
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(2) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(2) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(2) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(2) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ii = nbidta(ib,igrd,ib_bdy)- iw_b(2)+2
+                       if((com_east_b .ne. 1) .and. (ii .eq. 2)) then
+                          ij = nbjdta(ib,igrd,ib_bdy) - is_b(2)+2
+                          if((ij .eq. 2) .and. (nbondj .eq. 0 .or. nbondj .eq. 1)) then
+                            com_south = 1
+                          elseif((ij .eq. nlcjt(noea+1)-1) .and. (nbondj .eq. 0 .or. nbondj .eq. -1)) then
+                            com_north = 1
+                          endif
+                          com_east_b = 1
+                       endif 
+                     ENDIF
+                  ENDIF
+                  IF(nbondj .eq. 0) THEN
+                     IF(com_north_b .ne. 1 .AND. (nbidta(ib,igrd,ib_bdy) == iw_b(4)-1 .OR. nbidta(ib,igrd,ib_bdy) == ie_b(4)+1) .AND. &
+                       & nbjdta(ib,igrd,ib_bdy) == is_b(4) .AND. nbrdta(ib,igrd,ib_bdy) == ir) THEN
+                       com_north_b = 1 
+                     ENDIF
+                     IF(com_south_b .ne. 1 .AND. (nbidta(ib,igrd,ib_bdy) == iw_b(3)-1 .OR. nbidta(ib,igrd,ib_bdy) == ie_b(3)+1) .AND. &
+                       & nbjdta(ib,igrd,ib_bdy) == in_b(3) .AND. nbrdta(ib,igrd,ib_bdy) == ir) THEN
+                       com_south_b = 1 
+                     ENDIF
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(3) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(3) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(3) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(3) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ij = nbjdta(ib,igrd,ib_bdy)- is_b(3)+2
+                       if((com_south_b .ne. 1) .and. (ij .eq. (nlcjt(noso+1)-1))) then
+                          com_south_b = 1
+                       endif 
+                     ENDIF
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(4) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(4) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(4) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(4) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ij = nbjdta(ib,igrd,ib_bdy)- is_b(4)+2
+                       if((com_north_b .ne. 1) .and. (ij .eq. 2)) then
+                          com_north_b = 1
+                       endif 
+                     ENDIF
+                  ELSEIF(nbondj .eq. 1) THEN
+                     IF(com_south_b .ne. 1 .AND. (nbidta(ib,igrd,ib_bdy) == iw_b(3)-1 .OR. nbidta(ib,igrd,ib_bdy) == ie_b(3)+1) .AND. &
+                       & nbjdta(ib,igrd,ib_bdy) == in_b(3) .AND. nbrdta(ib,igrd,ib_bdy) == ir) THEN
+                       com_south_b = 1 
+                     ENDIF
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(3) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(3) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(3) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(3) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ij = nbjdta(ib,igrd,ib_bdy)- is_b(3)+2
+                       if((com_south_b .ne. 1) .and. (ij .eq. (nlcjt(noso+1)-1))) then
+                          com_south_b = 1
+                       endif 
+                     ENDIF
+                  ELSEIF(nbondj .eq. -1) THEN
+                     IF(com_north_b .ne. 1 .AND. (nbidta(ib,igrd,ib_bdy) == iw_b(4)-1 .OR. nbidta(ib,igrd,ib_bdy) == ie_b(4)+1) .AND. &
+                       & nbjdta(ib,igrd,ib_bdy) == is_b(4) .AND. nbrdta(ib,igrd,ib_bdy) == ir) THEN
+                       com_north_b = 1 
+                     ENDIF
+                     IF( nbidta(ib,igrd,ib_bdy) >= iw_b(4) .AND. nbidta(ib,igrd,ib_bdy) <= ie_b(4) .AND.   &
+                       & nbjdta(ib,igrd,ib_bdy) >= is_b(4) .AND. nbjdta(ib,igrd,ib_bdy) <= in_b(4) .AND.   &
+                       & nbrdta(ib,igrd,ib_bdy) == ir  ) THEN
+                       ij = nbjdta(ib,igrd,ib_bdy)- is_b(4)+2
+                       if((com_north_b .ne. 1) .and. (ij .eq. 2)) then
+                          com_north_b = 1
+                       endif 
+                     ENDIF
+                  ENDIF
                ENDDO
             ENDDO
          ENDDO 
+         ! definition of the i- and j- direction local boundaries arrays
+         ! used for sending the boudaries
+         IF((com_east .eq. 1) .and. (com_west .eq. 1)) THEN
+            nbondi_bdy(ib_bdy) = 0
+         ELSEIF ((com_east .eq. 1) .and. (com_west .eq. 0)) THEN
+            nbondi_bdy(ib_bdy) = -1
+         ELSEIF ((com_east .eq. 0) .and. (com_west .eq. 1)) THEN
+            nbondi_bdy(ib_bdy) = 1
+         ENDIF
+
+         IF((com_north .eq. 1) .and. (com_south .eq. 1)) THEN
+            nbondj_bdy(ib_bdy) = 0
+         ELSEIF ((com_north .eq. 1) .and. (com_south .eq. 0)) THEN
+            nbondj_bdy(ib_bdy) = -1
+         ELSEIF ((com_north .eq. 0) .and. (com_south .eq. 1)) THEN
+            nbondj_bdy(ib_bdy) = 1
+         ENDIF
+
+         ! definition of the i- and j- direction local boundaries arrays
+         ! used for receiving the boudaries
+         IF((com_east_b .eq. 1) .and. (com_west_b .eq. 1)) THEN
+            nbondi_bdy_b(ib_bdy) = 0
+         ELSEIF ((com_east_b .eq. 1) .and. (com_west_b .eq. 0)) THEN
+            nbondi_bdy_b(ib_bdy) = -1
+         ELSEIF ((com_east_b .eq. 0) .and. (com_west_b .eq. 1)) THEN
+            nbondi_bdy_b(ib_bdy) = 1
+         ENDIF
+
+         IF((com_north_b .eq. 1) .and. (com_south_b .eq. 1)) THEN
+            nbondj_bdy_b(ib_bdy) = 0
+         ELSEIF ((com_north_b .eq. 1) .and. (com_south_b .eq. 0)) THEN
+            nbondj_bdy_b(ib_bdy) = -1
+         ELSEIF ((com_north_b .eq. 0) .and. (com_south_b .eq. 1)) THEN
+            nbondj_bdy_b(ib_bdy) = 1
+         ENDIF
 
          ! Compute rim weights for FRS scheme
Index: /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3645)
+++ /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3646)
@@ -7,4 +7,5 @@
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!            3.5  !  2012     (S. Mocavero, I. Epicoco) Optimization of BDY communications
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -52,5 +53,5 @@
             CYCLE
          CASE(jp_frs)
-            CALL bdy_tra_frs( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
+            CALL bdy_tra_frs( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt, ib_bdy )
          CASE DEFAULT
             CALL ctl_stop( 'bdy_tra : unrecognised option for open boundaries for T and S' )
@@ -60,5 +61,5 @@
    END SUBROUTINE bdy_tra
 
-   SUBROUTINE bdy_tra_frs( idx, dta, kt )
+   SUBROUTINE bdy_tra_frs( idx, dta, kt, ib_bdy )
       !!----------------------------------------------------------------------
       !!                 ***  SUBROUTINE bdy_tra_frs  ***
@@ -71,4 +72,5 @@
       TYPE(OBC_INDEX), INTENT(in) ::   idx  ! OBC indices
       TYPE(OBC_DATA),  INTENT(in) ::   dta  ! OBC external data
+      INTEGER,         INTENT(in) ::   ib_bdy  ! BDY set index
       !! 
       REAL(wp) ::   zwgt           ! boundary weight
@@ -89,6 +91,5 @@
          END DO
       END DO 
-      !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
+      CALL lbc_bdy_lnk( tsa(:,:,:,jp_tem), 'T', 1., ib_bdy )   ; CALL lbc_bdy_lnk( tsa(:,:,:,jp_sal), 'T', 1., ib_bdy )    ! Boundary points should be updated
       !
       IF( kt .eq. nit000 ) CLOSE( unit = 102 )
Index: /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 3645)
+++ /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 3646)
@@ -8,4 +8,6 @@
    !!            3.3  ! 2010-11  (G. Madec) add mbk. arrays associated to the deepest ocean level
    !!            4.0  ! 2011-01  (A. R. Porter, STFC Daresbury) dynamical allocation
+   !!            3.5  ! 2012     (S. Mocavero, I. Epicoco) Add arrays associated
+   !!                             to the optimization of BDY communications
    !!----------------------------------------------------------------------
 
@@ -80,4 +82,9 @@
    INTEGER, PUBLIC ::   narea             !: number for local area
    INTEGER, PUBLIC ::   nbondi, nbondj    !: mark of i- and j-direction local boundaries
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondi_bdy(:)    !: mark i-direction local boundaries for BDY open boundaries
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondj_bdy(:)    !: mark j-direction local boundaries for BDY open boundaries
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondi_bdy_b(:)  !: mark i-direction of neighbours local boundaries for BDY open boundaries  
+   INTEGER, ALLOCATABLE, PUBLIC ::   nbondj_bdy_b(:)  !: mark j-direction of neighbours local boundaries for BDY open boundaries  
+
    INTEGER, PUBLIC ::   npolj             !: north fold mark (0, 3 or 4)
    INTEGER, PUBLIC ::   nlci, nldi, nlei  !: i-dimensions of the local subdomain and its first and last indoor indices
Index: /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lbclnk.F90
===================================================================
--- /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lbclnk.F90	(revision 3645)
+++ /branches/2012/dev_CMCC_INGV_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lbclnk.F90	(revision 3646)
@@ -7,4 +7,7 @@
    !!   NEMO     1.0  ! 2002-09  (G. Madec)     F90: Free form and module
    !!            3.2  ! 2009-03  (R. Benshila)  External north fold treatment  
+   !!            3.5  ! 2012     (S.Mocavero, I. Epicoco) Add 'lbc_bdy_lnk' 
+   !!                            and lbc_obc_lnk' routine to optimize  
+   !!                            the BDY/OBC communications
    !!----------------------------------------------------------------------
 #if   defined key_mpp_mpi
@@ -14,4 +17,6 @@
    !!   lbc_lnk      : generic interface for mpp_lnk_3d and mpp_lnk_2d routines defined in lib_mpp
    !!   lbc_lnk_e    : generic interface for mpp_lnk_2d_e routine defined in lib_mpp
+   !!   lbc_bdy_lnk  : generic interface for mpp_lnk_bdy_2d and mpp_lnk_bdy_3d routines defined in lib_mpp
+   !!   lbc_obc_lnk  : generic interface for mpp_lnk_obc_2d and mpp_lnk_obc_3d routines defined in lib_mpp
    !!----------------------------------------------------------------------
    USE lib_mpp          ! distributed memory computing library
@@ -21,4 +26,11 @@
    END INTERFACE
 
+   INTERFACE lbc_bdy_lnk
+      MODULE PROCEDURE mpp_lnk_bdy_2d, mpp_lnk_bdy_3d
+   END INTERFACE
+   INTERFACE lbc_obc_lnk
+      MODULE PROCEDURE mpp_lnk_obc_2d, mpp_lnk_obc_3d
+   END INTERFACE
+
    INTERFACE lbc_lnk_e
       MODULE PROCEDURE mpp_lnk_2d_e
@@ -27,4 +39,6 @@
    PUBLIC lbc_lnk       ! ocean lateral boundary conditions
    PUBLIC lbc_lnk_e
+   PUBLIC lbc_bdy_lnk   ! ocean lateral BDY boundary conditions
+   PUBLIC lbc_obc_lnk   ! ocean lateral BDY boundary conditions
 
    !!----------------------------------------------------------------------
@@ -41,4 +55,6 @@
    !!   lbc_lnk_3d   : set the lateral boundary condition on a 3D variable on ocean mesh
    !!   lbc_lnk_2d   : set the lateral boundary condition on a 2D variable on ocean mesh
+   !!   lbc_bdy_lnk  : set the lateral BDY boundary condition
+   !!   lbc_obc_lnk  : set the lateral OBC boundary condition
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers   
@@ -58,6 +74,15 @@
    END INTERFACE
 
+   INTERFACE lbc_bdy_lnk
+      MODULE PROCEDURE lbc_bdy_lnk_2d, lbc_bdy_lnk_3d
+   END INTERFACE
+   INTERFACE lbc_obc_lnk
+      MODULE PROCEDURE lbc_lnk_2d, lbc_lnk_3d
+   END INTERFACE
+
    PUBLIC   lbc_lnk       ! ocean/ice  lateral boundary conditions
    PUBLIC   lbc_lnk_e 
+   PUBLIC   lbc_bdy_lnk   ! ocean lateral BDY boundary conditions
+   PUBLIC   lbc_obc_lnk   ! ocean lateral OBC boundary conditions
    
    !!----------------------------------------------------------------------
@@ -180,4 +205,37 @@
    END SUBROUTINE lbc_lnk_3d
 
+   SUBROUTINE lbc_bdy_lnk_3d( pt3d, cd_type, psgn, ib_bdy )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE lbc_bdy_lnk  ***
+      !!
+      !! ** Purpose :   wrapper rountine to 'lbc_lnk_3d'. This wrapper is used
+      !!                to maintain the same interface with regards to the mpp case
+      !!
+      !!----------------------------------------------------------------------
+      CHARACTER(len=1)                , INTENT(in   )           ::   cd_type   ! nature of pt3d grid-points
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)           ::   pt3d      ! 3D array on which the lbc is applied
+      REAL(wp)                        , INTENT(in   )           ::   psgn      ! control of the sign 
+      INTEGER                                                   ::   ib_bdy    ! BDY boundary set
+      !!
+      CALL lbc_lnk_3d( pt3d, cd_type, psgn)
+
+   END SUBROUTINE lbc_bdy_lnk_3d
+
+   SUBROUTINE lbc_bdy_lnk_2d( pt2d, cd_type, psgn, ib_bdy )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE lbc_bdy_lnk  ***
+      !!
+      !! ** Purpose :   wrapper rountine to 'lbc_lnk_3d'. This wrapper is used
+      !!                to maintain the same interface with regards to the mpp case
+      !!
+      !!----------------------------------------------------------------------
+      CHARACTER(len=1)                , INTENT(in   )           ::   cd_type   ! nature of pt3d grid-points
+      REAL(wp), DIMENSION(jpi,jpj),     INTENT(inout)           ::   pt2d      ! 3D array on which the lbc is applied
+      REAL(wp)                        , INTENT(in   )           ::   psgn      ! control of the sign 
+      INTEGER                                                   ::   ib_bdy    ! BDY boundary set
+      !!
+      CALL lbc_lnk_2d( pt2d, cd_type, psgn)
+
+   END SUBROUTINE lbc_bdy_lnk_2d
 
    SUBROUTINE lbc_lnk_2d( pt2d, cd_type, psgn, cd_mpp, pval )
